import { Socket } from '../../Sockets/Socket.js';
import { Node } from '../Node.js';
export class In2Out1FuncNode extends Node {
    constructor(description, graph, inputValueTypes, outputValueType, binaryEvalFunc, inputNames = ['a', 'b']) {
        if (inputValueTypes.length !== 2) {
            throw new Error(`inputValueTypes must have a length of 2, it is instead ${inputValueTypes.length}`);
        }
        if (inputNames.length !== 2) {
            throw new Error(`inputNames must have a length of 2, it is instead ${inputNames.length}`);
        }
        super(description, graph, [
            new Socket(inputValueTypes[0], inputNames[0]),
            new Socket(inputValueTypes[1], inputNames[1])
        ], [new Socket(outputValueType, 'result')], (context) => {
            context.writeOutput('result', this.binaryEvalFunc(context.readInput(inputNames[0]), context.readInput(inputNames[1])));
        });
        this.binaryEvalFunc = binaryEvalFunc;
        this.inputNames = inputNames;
    }
}
//# sourceMappingURL=In2Out1FuncNode.js.map