import { Socket } from '../../Sockets/Socket.js';
import { Node } from '../Node.js';
export class In4Out1FuncNode extends Node {
    constructor(description, graph, inputValueTypes, outputValueType, binaryEvalFunc, inputNames = ['a', 'b', 'c', 'd']) {
        if (inputValueTypes.length !== 4) {
            throw new Error(`inputValueTypes must have a length of 4, it is instead ${inputValueTypes.length}`);
        }
        if (inputNames.length !== 4) {
            throw new Error(`inputNames must have a length of 4, it is instead ${inputNames.length}`);
        }
        super(description, graph, [
            new Socket(inputValueTypes[0], inputNames[0]),
            new Socket(inputValueTypes[1], inputNames[1]),
            new Socket(inputValueTypes[2], inputNames[2]),
            new Socket(inputValueTypes[3], inputNames[3])
        ], [new Socket(outputValueType, 'result')], (context) => {
            context.writeOutput('result', this.binaryEvalFunc(context.readInput(inputNames[0]), context.readInput(inputNames[1]), context.readInput(inputNames[2]), context.readInput(inputNames[3])));
        });
        this.binaryEvalFunc = binaryEvalFunc;
        this.inputNames = inputNames;
    }
}
//# sourceMappingURL=In4Out1FuncNode.js.map