import { Node } from '../../../Nodes/Node.js';
import { NodeDescription } from '../../../Nodes/NodeDescription.js';
import { Socket } from '../../../Sockets/Socket.js';
export class TriggerCustomEvent extends Node {
    constructor(description, graph, customEvent) {
        super(description, graph, [
            new Socket('flow', 'flow'),
            ...customEvent.parameters.map((parameter) => new Socket(parameter.valueTypeName, parameter.name, parameter.value, parameter.label))
        ], [new Socket('flow', 'flow')], (context) => {
            const parameters = {};
            customEvent.parameters.forEach((parameterSocket) => {
                parameters[parameterSocket.name] = context.readInput(parameterSocket.name);
            });
            customEvent.eventEmitter.emit(parameters);
        });
        this.customEvent = customEvent;
    }
    static GetDescription(graph, customEventId) {
        const customEvent = graph.customEvents[customEventId];
        return new NodeDescription(`customEvent/trigger/${customEvent.id}`, 'Action', `Trigger ${customEvent.name}`, (description, graph) => new TriggerCustomEvent(description, graph, customEvent));
    }
}
//# sourceMappingURL=TriggerCustomEvent.js.map