import { Assert } from '../../../Diagnostics/Assert.js';
import { Node } from '../../../Nodes/Node.js';
import { NodeDescription } from '../../../Nodes/NodeDescription.js';
import { Socket } from '../../../Sockets/Socket.js';
export class ExpectTrue extends Node {
    constructor(description, graph) {
        super(description, graph, [
            new Socket('flow', 'flow'),
            new Socket('boolean', 'condition'),
            new Socket('string', 'description')
        ], [new Socket('flow', 'flow')], (context) => {
            Assert.mustBeTrue(context.readInput('condition'), context.readInput('description'));
        });
    }
}
ExpectTrue.Description = new NodeDescription('debug/expectTrue', 'Action', 'Assert Expect True', (description, graph) => new ExpectTrue(description, graph));
//# sourceMappingURL=AssertExpectTrue.js.map