import { Node } from '../../../Nodes/Node.js';
import { NodeDescription } from '../../../Nodes/NodeDescription.js';
import { Socket } from '../../../Sockets/Socket.js';
export class Log extends Node {
    constructor(description, graph) {
        super(description, graph, [new Socket('flow', 'flow'), new Socket('string', 'text')], [new Socket('flow', 'flow')], (context) => {
            const logger = context.graph.registry.abstractions.get('ILogger');
            logger.info(context.readInput('text'));
        });
    }
}
Log.Description = new NodeDescription('debug/log', 'Action', 'Debug Log', (description, graph) => new Log(description, graph));
//# sourceMappingURL=DebugLog.js.map