import { Node } from '../../../Nodes/Node.js';
import { NodeDescription } from '../../../Nodes/NodeDescription.js';
import { Socket } from '../../../Sockets/Socket.js';
export class Delay extends Node {
    constructor(description, graph) {
        super(description, graph, [new Socket('flow', 'flow'), new Socket('float', 'duration')], [new Socket('flow', 'flow')], (context) => {
            let timeIsCancelled = false;
            setTimeout(() => {
                if (timeIsCancelled) {
                    return;
                }
                context.commit('flow');
                context.finish();
            }, context.readInput('duration') * 1000);
            context.onAsyncCancelled.addListener(() => {
                timeIsCancelled = true;
            });
        });
        this.async = true;
    }
}
Delay.Description = new NodeDescription('flow/delay', 'Flow', 'Delay', (description, graph) => new Delay(description, graph));
//# sourceMappingURL=Delay.js.map