import { Node } from '../../../Nodes/Node.js';
import { NodeDescription } from '../../../Nodes/NodeDescription.js';
import { Socket } from '../../../Sockets/Socket.js';
export class FlipFlop extends Node {
    constructor(description, graph) {
        super(description, graph, [new Socket('flow', 'flow')], [
            new Socket('flow', 'on'),
            new Socket('flow', 'off'),
            new Socket('boolean', 'isOn')
        ], (context) => {
            context.writeOutput('isOn', this.isOn);
            context.commit(this.isOn ? 'on' : 'off');
            this.isOn = !this.isOn;
        });
        this.isOn = true;
    }
}
FlipFlop.Description = new NodeDescription('flow/flipFlop', 'Flow', 'Flip Flop', (description, graph) => new FlipFlop(description, graph));
//# sourceMappingURL=FlipFlop.js.map