import { Node } from '../../../Nodes/Node.js';
import { NodeDescription } from '../../../Nodes/NodeDescription.js';
import { Socket } from '../../../Sockets/Socket.js';
export class ForLoop extends Node {
    constructor(description, graph) {
        super(description, graph, [
            new Socket('flow', 'flow'),
            new Socket('integer', 'startIndex'),
            new Socket('integer', 'endIndex')
        ], [
            new Socket('flow', 'loopBody'),
            new Socket('integer', 'index'),
            new Socket('flow', 'completed')
        ], (context) => {
            const startIndex = context.readInput('startIndex');
            const endIndex = context.readInput('endIndex');
            const loopBodyIteration = function loopBodyIteration(i) {
                if (i < endIndex) {
                    context.writeOutput('index', i);
                    context.commit('loopBody', () => {
                        loopBodyIteration(i + 1n);
                    });
                }
                else {
                    context.commit('completed');
                }
            };
            loopBodyIteration(startIndex);
        });
    }
}
ForLoop.Description = new NodeDescription('flow/forLoop', 'Flow', 'For Loop', (description, graph) => new ForLoop(description, graph));
//# sourceMappingURL=ForLoop.js.map