import { Node } from '../../../Nodes/Node.js';
import { NodeDescription } from '../../../Nodes/NodeDescription.js';
import { Socket } from '../../../Sockets/Socket.js';
export class LifecycleOnStart extends Node {
    constructor(description, graph) {
        super(description, graph, [], [new Socket('flow', 'flow')], (context) => {
            const onStartEvent = () => {
                context.commit('flow');
            };
            const lifecycleEvents = context.graph.registry.abstractions.get('ILifecycleEventEmitter');
            lifecycleEvents.startEvent.addListener(onStartEvent);
            context.onAsyncCancelled.addListener(() => {
                lifecycleEvents.startEvent.removeListener(onStartEvent);
            });
        });
        this.async = true;
        this.evaluateOnStartup = true;
        this.interruptibleAsync = true;
    }
}
LifecycleOnStart.Description = new NodeDescription('lifecycle/onStart', 'Event', 'On Start', (description, graph) => new LifecycleOnStart(description, graph));
//# sourceMappingURL=LifecycleOnStart.js.map