import { Node } from '../../../Nodes/Node.js';
import { NodeDescription } from '../../../Nodes/NodeDescription.js';
import { Socket } from '../../../Sockets/Socket.js';
export class VariableGet extends Node {
    constructor(description, graph, variable) {
        super(description, graph, [], [new Socket(variable.valueTypeName, 'value', undefined, variable.name)], (context) => {
            context.writeOutput('value', variable.get());
        });
        this.variable = variable;
    }
    static GetDescription(graph, variableId) {
        const variable = graph.variables[variableId];
        return new NodeDescription(`variable/get/${variable.id}`, 'Query', '', (description, graph) => new VariableGet(description, graph, variable));
    }
}
//# sourceMappingURL=VariableGet.js.map