import { Node } from '../../../Nodes/Node.js';
import { NodeDescription } from '../../../Nodes/NodeDescription.js';
import { Socket } from '../../../Sockets/Socket.js';
export class VariableSet extends Node {
    constructor(description, graph, variable) {
        super(description, graph, [
            new Socket('flow', 'flow'),
            new Socket(variable.valueTypeName, 'value', undefined, variable.name)
        ], [new Socket('flow', 'flow')], (context) => {
            variable.set(context.readInput('value'));
        });
        this.variable = variable;
    }
    static GetDescription(graph, variableId) {
        const variable = graph.variables[variableId];
        return new NodeDescription(`variable/set/${variable.id}`, 'Action', `Set`, (description, graph) => new VariableSet(description, graph, variable));
    }
}
//# sourceMappingURL=VariableSet.js.map