import { In0Out1FuncNode } from '../../Nodes/Templates/In0Out1FuncNode.js';
import { In1Out1FuncNode } from '../../Nodes/Templates/In1Out1FuncNode.js';
import { In2Out1FuncNode } from '../../Nodes/Templates/In2Out1FuncNode.js';
import { In3Out1FuncNode } from '../../Nodes/Templates/In3Out1FuncNode.js';
export function registerFloatValue(registry) {
    const { nodes, values } = registry;
    nodes.register('logic/float', () => new In1Out1FuncNode('logic/float', 'float', 'float', (a) => a));
    nodes.register('logic/add/float', () => new In2Out1FuncNode('logic/add/float', 'float', 'float', 'float', (a, b) => a + b));
    nodes.register('logic/subtract/float', () => new In2Out1FuncNode('logic/subtract/float', 'float', 'float', 'float', (a, b) => a - b));
    nodes.register('logic/multiply/float', () => new In2Out1FuncNode('logic/multiply/float', 'float', 'float', 'float', (a, b) => a * b));
    nodes.register('logic/divide/float', () => new In2Out1FuncNode('logic/divide/float', 'float', 'float', 'float', (a, b) => a / b));
    nodes.register('logic/pow/float', () => new In2Out1FuncNode('logic/pow/float', 'float', 'float', 'float', (a, b) => a ** b));
    nodes.register('logic/negate/float', () => new In1Out1FuncNode('logic/negate/float', 'float', 'float', (a) => -a));
    nodes.register('logic/sqrt/float', () => new In1Out1FuncNode('logic/sqrt/float', 'float', 'float', (a) => Math.sqrt(a)));
    nodes.register('logic/modulus/float', () => new In2Out1FuncNode('logic/modulus/float', 'float', 'float', 'float', (a, b) => a % b));
    nodes.register('logic/E/float', () => new In0Out1FuncNode('logic/E/float', 'float', () => Math.E));
    nodes.register('logic/exp/float', () => new In1Out1FuncNode('logic/exp/float', 'float', 'float', (a) => Math.exp(a)));
    nodes.register('logic/log/float', () => new In1Out1FuncNode('logic/log/float', 'float', 'float', (a) => Math.log(a)));
    nodes.register('logic/log2/float', () => new In1Out1FuncNode('logic/log2/float', 'float', 'float', (a) => Math.log2(a)));
    nodes.register('logic/log10/float', () => new In1Out1FuncNode('logic/log10/float', 'float', 'float', (a) => Math.log10(a)));
    nodes.register('logic/PI/float', () => new In0Out1FuncNode('logic/PI/float', 'float', () => Math.PI));
    nodes.register('logic/sin/float', () => new In1Out1FuncNode('logic/sin/float', 'float', 'float', (a) => Math.sin(a)));
    nodes.register('logic/asin/float', () => new In1Out1FuncNode('logic/asin/float', 'float', 'float', (a) => Math.asin(a)));
    nodes.register('logic/cos/float', () => new In1Out1FuncNode('logic/cos/float', 'float', 'float', (a) => Math.cos(a)));
    nodes.register('logic/acos/float', () => new In1Out1FuncNode('logic/acos/float', 'float', 'float', (a) => Math.acos(a)));
    nodes.register('logic/tan/float', () => new In1Out1FuncNode('logic/tan/float', 'float', 'float', (a) => Math.tan(a)));
    nodes.register('logic/atan/float', () => new In1Out1FuncNode('logic/atan/float', 'float', 'float', (a) => Math.atan(a)));
    nodes.register('logic/mix/float', () => new In3Out1FuncNode('logic/mix/float', 'float', 'float', 'float', 'float', (a, b, c) => {
        const s = 1 - c;
        return a * s + b * c;
    }));
    nodes.register('logic/min/float', () => new In2Out1FuncNode('logic/min/float', 'float', 'float', 'float', (a, b) => Math.min(a, b)));
    nodes.register('logic/max/float', () => new In2Out1FuncNode('logic/max/float', 'float', 'float', 'float', (a, b) => Math.max(a, b)));
    nodes.register('logic/sign/float', () => new In1Out1FuncNode('logic/sign/float', 'float', 'integer', (a) => BigInt(Math.sign(a))));
    nodes.register('logic/abs/float', () => new In1Out1FuncNode('logic/abs/float', 'float', 'float', (a) => Math.abs(a)));
    nodes.register('logic/floor/float', () => new In1Out1FuncNode('logic/floor/float', 'float', 'integer', (a) => BigInt(Math.floor(a))));
    nodes.register('logic/ceil/float', () => new In1Out1FuncNode('logic/ceil/float', 'float', 'integer', (a) => BigInt(Math.ceil(a))));
    nodes.register('logic/round/float', () => new In1Out1FuncNode('logic/round/float', 'float', 'integer', (a) => BigInt(Math.round(a))));
    nodes.register('logic/trunc/float', () => new In1Out1FuncNode('logic/trunc/float', 'float', 'integer', (a) => BigInt(Math.trunc(a))));
    nodes.register('logic/sample/float', () => new In0Out1FuncNode('logic/sample/float', 'float', () => Math.random()));
    nodes.register('logic/equal/float', () => new In2Out1FuncNode('logic/equal/float', 'float', 'float', 'boolean', (a, b) => a === b));
    nodes.register('logic/greaterThan/float', () => new In2Out1FuncNode('logic/greaterThan/float', 'float', 'float', 'boolean', (a, b) => a > b));
    nodes.register('logic/greaterThanOrEqual/float', () => new In2Out1FuncNode('logic/greaterThanOrEqual/float', 'float', 'float', 'boolean', (a, b) => a >= b));
    nodes.register('logic/lessThan/float', () => new In2Out1FuncNode('logic/lessThan/float', 'float', 'float', 'boolean', (a, b) => a < b));
    nodes.register('logic/lessThanOrEqual/float', () => new In2Out1FuncNode('logic/lessThanOrEqual/float', 'float', 'float', 'boolean', (a, b) => a <= b));
    nodes.register('logic/isNan/float', () => new In1Out1FuncNode('logic/isNan/float', 'float', 'boolean', (a) => Number.isNaN(a)));
    nodes.register('logic/isInf/float', () => new In1Out1FuncNode('logic/isInf/float', 'float', 'boolean', (a) => !Number.isFinite(a) && !Number.isNaN(a)));
    return registry;
}
//# sourceMappingURL=registerFloatValue.js.map