import { In1Out1FuncNode } from '../../Nodes/Templates/In1Out1FuncNode.js';
import { In2Out1FuncNode } from '../../Nodes/Templates/In2Out1FuncNode.js';
export function registerIntegerValue(registry) {
    const { nodes, values } = registry;
    nodes.register('logic/integer', () => new In1Out1FuncNode('logic/integer', 'integer', 'integer', (a) => a));
    nodes.register('logic/add/integer', () => new In2Out1FuncNode('logic/add/integer', 'integer', 'integer', 'integer', (a, b) => a + b));
    nodes.register('logic/subtract/integer', () => new In2Out1FuncNode('logic/subtract/integer', 'integer', 'integer', 'integer', (a, b) => a - b));
    nodes.register('logic/multiply/integer', () => new In2Out1FuncNode('logic/multiply/integer', 'integer', 'integer', 'integer', (a, b) => a * b));
    nodes.register('logic/divide/integer', () => new In2Out1FuncNode('logic/divide/integer', 'integer', 'integer', 'integer', (a, b) => a / b));
    nodes.register('logic/negate/integer', () => new In1Out1FuncNode('logic/negate/integer', 'integer', 'integer', (a) => -a));
    nodes.register('logic/modulus/integer', () => new In2Out1FuncNode('logic/modulus/integer', 'integer', 'integer', 'integer', (a, b) => a % b));
    nodes.register('logic/toFloat/integer', () => new In1Out1FuncNode('logic/toFloat/integer', 'integer', 'float', (a) => Number(a)));
    nodes.register('logic/min/integer', () => new In2Out1FuncNode('logic/min/integer', 'integer', 'integer', 'integer', (a, b) => (a > b ? b : a)));
    nodes.register('logic/max/integer', () => new In2Out1FuncNode('logic/max/integer', 'integer', 'integer', 'integer', (a, b) => (a > b ? a : b)));
    nodes.register('logic/abs/integer', () => new In1Out1FuncNode('logic/abs/integer', 'integer', 'integer', (a) => (a < 0n ? -a : a)));
    nodes.register('logic/sign/integer', () => new In1Out1FuncNode('logic/sign/integer', 'integer', 'integer', (a) => (a < 0n ? -1n : a > 0n ? 1n : 0n)));
    nodes.register('logic/equal/integer', () => new In2Out1FuncNode('logic/equal/integer', 'integer', 'integer', 'boolean', (a, b) => a === b));
    nodes.register('logic/greaterThan/integer', () => new In2Out1FuncNode('logic/greaterThan/integer', 'integer', 'integer', 'boolean', (a, b) => a > b));
    nodes.register('logic/greaterThanOrEqual/integer', () => new In2Out1FuncNode('logic/greaterThanOrEqual/integer', 'integer', 'integer', 'boolean', (a, b) => a >= b));
    nodes.register('logic/lessThan/integer', () => new In2Out1FuncNode('logic/lessThan/integer', 'integer', 'integer', 'boolean', (a, b) => a < b));
    nodes.register('logic/lessThanOrEqual/integer', () => new In2Out1FuncNode('logic/lessThanOrEqual/integer', 'integer', 'integer', 'boolean', (a, b) => a <= b));
    return registry;
}
//# sourceMappingURL=registerIntegerValue.js.map