import { Node } from '../../../Nodes/Node.js';
import { NodeDescription } from '../../../Nodes/NodeDescription.js';
import { Socket } from '../../../Sockets/Socket.js';
import { toCamelCase } from '../../../toCamelCase.js';
export class SetSceneProperty extends Node {
    static GetDescriptions(...valueTypeNames) {
        return valueTypeNames.map((valueTypeName) => new NodeDescription(`scene/set/${valueTypeName}`, 'Action', `Set Scene ${toCamelCase(valueTypeName)}`, (description, graph) => new SetSceneProperty(description, graph, valueTypeName)));
    }
    constructor(description, graph, valueTypeName) {
        super(description, graph, [
            new Socket('flow', 'flow'),
            new Socket('string', 'jsonPath'),
            new Socket(valueTypeName, 'value')
        ], [new Socket('flow', 'flow')], (context) => {
            const scene = context.graph.registry.abstractions.get('IScene');
            const value = context.readInput('value');
            scene.setProperty(context.readInput('jsonPath'), valueTypeName, value);
        });
    }
}
//# sourceMappingURL=SetSceneProperty.js.map