import { Node } from '../../../Nodes/Node.js';
import { NodeDescription } from '../../../Nodes/NodeDescription.js';
import { Socket } from '../../../Sockets/Socket.js';
import { toCamelCase } from '../../../toCamelCase.js';
export class GetSceneProperty extends Node {
    static GetDescriptions(...valueTypeNames) {
        return valueTypeNames.map((valueTypeName) => new NodeDescription(`scene/get/${valueTypeName}`, 'Query', `Get Scene ${toCamelCase(valueTypeName)}`, (description, graph) => new GetSceneProperty(description, graph, valueTypeName)));
    }
    constructor(description, graph, valueTypeName) {
        super(description, graph, [new Socket('flow', 'flow'), new Socket('string', 'jsonPath')], [new Socket('flow', 'flow'), new Socket(valueTypeName, 'value')], (context) => {
            const sceneGraph = context.graph.registry.abstractions.get('IScene');
            context.writeOutput('value', sceneGraph.getProperty(context.readInput('jsonPath'), valueTypeName));
        });
    }
}
//# sourceMappingURL=GetSceneProperty.js.map